import { __awaiter } from "tslib";
/**
 * These DS / Component imports will be replaced with an import from the local alpha design system.
 * We're just fixing something on our side to allow you to extend zero.
 */
import { allComponents, provideFASTDesignSystem } from '@microsoft/fast-components';
import { logger } from '../utils';
provideFASTDesignSystem().register(allComponents);
var ResourceType;
(function (ResourceType) {
    ResourceType["local"] = "local";
    ResourceType["remote"] = "remote";
})(ResourceType || (ResourceType = {}));
function loadZeroFallback() {
    return import(
    /* webpackMode: "lazy" */
    '@genesislcap/foundation-zero');
}
export const loadZeroDesignSystem = () => __awaiter(void 0, void 0, void 0, function* () {
    let type = ResourceType.remote;
    try {
        // @ts-ignore
        return yield import('foundationZero/ZeroDesignSystem');
    }
    catch (e) {
        type = ResourceType.local;
        return yield loadZeroFallback();
    }
    finally {
        logger.debug(`Using '${type}' version of foundationZero/DesignSystem`);
    }
});
/**
 * Load the wp5 module federation remote versions, or fallback to code split bundled versions.
 * You would really be targeting the client's design system, components etc here. For now just targeting zero.
 */
export const loadRemotes = () => __awaiter(void 0, void 0, void 0, function* () {
    const { registerZeroDesignSystem } = yield loadZeroDesignSystem();
    return {
        ZeroDesignSystem: registerZeroDesignSystem(),
    };
});
